Description

Source code:

$group = new Form_Group("ICMP6 types");

$group->add(new Form_Select(

    'icmptype6',

    'Select some ICMP6 types',

    $selectedtypes,

    $alltypes,

    true

))->addClass('icmp6showhide');

$group->addClass('icmp6showhide');

$section->add($group);

<!-- more code, usual CDATA, etc -->

<script>

    $('#icmptype6').change(function() {

        alert("change event triggered");

        // do stuff here

    });

    // NB - same result happens with .on('change', function {}) instead of .change(function {})

</script>

 Ignoring trivial divs, the bootstrap code produces this as the output HTML:

<select class="form-control icmp6showhide" name="icmptype6[]" id="icmptype6[]" multiple="multiple"

>

    <option value="any">any</option>

    <option value="echorep" selected>Echo reply</option>

    <option value="echoreq">Echo request</option>

    ...

</select>

 The expected result is that the event is triggered as usual and the event code runs, when options in the select box are

selected/deselected, but it doesn't. When I looked at the source code which bootstrap had produced, the issue is clear but it is not

fixable within my knowhow, and there are compatibility issues that need more skill to get right.

What's happening is that for a multiple select box called "xyz", the bootstrap code produces HTML with id="xyz[]", which doesn't

match the usual jQuery trigger $("#xyz").change(function {}), and as the two element id's aren't the same, nothing triggers. If the

output HTML is manually saved and the select box element edited to remove the "[]", leaving just id="xyz", it works, so the underlying

cause is clear.

The problem bites hard because

(1) I can't change id="xyz[]" to id="xyz" on the element in the GUI code, because that part is auto-generated by the bootstrap code

itself; but also
(2) I can't change the trigger script to refer to $("#xyz[]").on(...) either, because it's either invalid or for other reasons doesn't work.

So the effect is I can't set an event on a select box, if it's a multiple select box.

History

#1 - 09/11/2016 10:03 AM - Anonymous

- Assignee set to Anonymous

#2 - 09/11/2016 02:52 PM - Stilez y

For anyone needing a workaround, or if it's useful, I just googled "jquery square brackets" and found two syntaxes that can help:

Escaping the brackets:  $('#icmptype6\\[\\]')

Using explicit attributes $('select[id="icmp6[]"]')

I'm not sure if these solve the problem (ie it's not really a "problem"), or just a workaround, and in either case if we can modify the class functions in

pfSense so that for multiple selection the id one uses in script is the same as that which is used in the bootstrap form creation code.

#3 - 09/11/2016 02:53 PM - Stilez y

(also it's not clear to me if all browsers add "[]" and if there's a remaining compatibility issue in here)

#4 - 09/12/2016 09:22 AM - Anonymous

- Category set to Web Interface

- Status changed from New to Not a Bug

- Assignee changed from Anonymous to Stilez y

The jQuery "begins with" syntax works with this type of control. Try:

$group = new Form_Group("ICMP6 types");

$group->add(new Form_Select(

    'icmptype6',

    'Select some ICMP6 types',

    $selectedtypes,

    $alltypes,

    true

))->addClass('icmp6showhide');

$group->addClass('icmp6showhide');

$section->add($group);

<script>

    $('[id^=icmptype6]').change(function() {

        alert("change event triggered");

    });

</script>

 I'm not aware of a browser that doesn't understand the array[] syntax for multiselects.

Obviously the start of the id needs to be unique.
